' $linesize:132
' $title: 'Alias sub (c) Greg Snyder'
' $INCLUDE: 'RBBS-VAR.BAS'
'
' $SUBTITLE: 'AliasChk - Checks whether ALIAS exists'
' $PAGE
'
'  SUBROUTINE NAME    -- AliasChk
'
'  INPUT PARAMETERS   --     PARAMETER                    MEANING
'                         WhoFind$                    ALIAS to find
'
'  OUTPUT PARAMETERS  --  WhoFound                    Whether ALIAS found
'                         UserNumFound                Record # of User
'
'  SUBROUTINE PURPOSE --  Validate that ALIAS exists.  Get User Record
'
2257 SUB AliasChk (WhoFind$,WhoFound,UserNumFound) STATIC
     IF WhoFound = ZTrue THEN EXIT SUB
     CALL BreakFileName (ZMainUserFile$,Drive$,Prefix$,Ext$,ZTrue)
     DGSTemp = INSTR(ZConfName$," ")
     IF DGSTemp > 0 THEN _
      DGSFileName$ = Drive$ + LEFT$(ZConfName$,DGSTemp-1) + "A.DEF" _
     ELSE DGSFileName$ = Drive$ + ZConfName$ + "A.DEF"
     CALL FindIt (DGSFileName$)
     IF NOT ZOK THEN _
        EXIT SUB
Call OpenWork (7,DGSFileName$)
     WhoFound=ZFalse
     DGSAlias$ = ""
     WHILE DGSAlias$ = "" AND NOT EOF(7)
        INPUT #7, DGSUserName$, DGSTempAlias$
        IF INSTR(DGSTempAlias$,WhoFind$) > 0 THEN
          ZSubParm = 1
          ZOutTxt$ = "Send to "+ DGSTempAlias$ +"([Y],N) "
          Call TGet
           IF ZSubParm = -1 THEN _
              EXIT SUB
           IF ZWasQ=0 THEN ZYes = ZTrue
               IF ZYes THEN
                  WhoFound = ZTrue                                   'Pe 04/04/92
                  WhoFind$ = DGSTempAlias$
                  DGSAlias$ = DGSUserName$
               END IF
          END IF
     WEND
     CLOSE 7
   END SUB
59750' $SUBTITLE: 'AliasDGS - Subroutine to Create/Update Alias Info file'
' $PAGE
'
'  SUBROUTINE NAME    -- DGSAlias
'
'  INPUT PARAMETERS   --     PARAMETER                    MEANING
'                         ZConfName$                  CONFERENCE NAME
'                         ZOrigUserNameDGS$           USERS - LOG ON NAME
'                         DGSAlias$                   USERS - ALIAS NAME
'                         DGSStl$                     NULL FIRST TIME IN
'                                                     'STILL' IF ALIAS EXISTS
'                                                        OR REAL NAME
'                         DGSFileName$                CONFERENCE ALIAS FILE
'
'  OUTPUT PARAMETERS  --  ZConfName$ ZOrigUserNameDGS$ DGSAlias$ DGSStl$
'                         DGSFileName$
'
'  SUBROUTINE PURPOSE --  TO Read ConfA.DEF and Get Users ALIAS or
'                         Create One
'
     SUB AliasDGS (ZConfName$,ZOrigUserNameDGS$,DGSAlias$,DGSStl$,DGSFileName$) STATIC
'
     ZAliasMode = ZFalse                                             ' RM051401
     IF DGSStl$ = "" THEN
        ConfADefFlag = 0
        CALL BreakFileName (ZMainUserFile$,Drive$,Prefix$,Ext$,ZTrue)
        DGSFileName$ = Drive$ + ZConfName$ + "A.DEF"
        CALL FindIt (DGSFileName$)
        IF ZOK THEN                                                  ' RM051401
           ConfADefFlag = ZTrue                                      ' RM051401
           ZAliasMode = ZTrue                                        ' RM051401
        END IF
        IF ConfADefFlag = ZTrue THEN
         Call OpenWork (7,DGSFileName$)
           DGSAlias$ = ""
           WHILE DGSAlias$ = "" AND NOT EOF(7)
              INPUT #7, DGSUserName$, DGSTempAlias$
              DGSUnl = LEN(DGSUserName$)
              IF DGSUserName$ = LEFT$(ZOrigUserNameDGS$,DGSUnl) THEN
                 DGSAlias$ = DGSTempAlias$
              END IF
           WEND
           CLOSE 7
        ELSE
           DGSAlias$ = "NO CONFA.DEF"
           EXIT SUB
        END IF
     END IF
     CALL GoodAls (ZConfName$,ZOrigUserNameDGS$,DGSAlias$,DGSStl$,DGSFileName$)
     END SUB
'
'
' $SUBTITLE: 'GoodAls - Subroutine to Make Sure Alias Good'
' $PAGE
'
'  SUBROUTINE NAME    -- GoodAls
'
'  INPUT PARAMETERS   --     PARAMETER                    MEANING
'                         ZConfName$                  CONFERENCE NAME
'                         ZOrigUserNameDGS$           USERS - LOG ON NAME
'                         DGSAlias$                   USERS - ALIAS NAME
'                         DGSStl$                     NULL FIRST TIME IN
'                                                      'STILL' IF ALIAS EXISTS
'                                                         OR REAL NAME
'                         DGSFileName$                CONFERENCE ALIAS FILE
'
'  OUTPUT PARAMETERS  --  ZConfName$ ZOrigUserNameDGS$ DGSAlias$ DGSStl$
'                         DGSFileName$
'
'  SUBROUTINE PURPOSE --  To Read ConfA.DEF and see if Users ALIAS is
'                         Aready in Use or a Real Name
'
     SUB GoodAls (ZConfName$,ZOrigUserNameDGS$,DGSAlias$,DGSStl$,DGSFileName$) STATIC
'
     IF DGSAlias$ = "" THEN
        DGSSfnSln$ = ZSysopFirstName$+" "+ZSysopLastName$
        ZOutTxt$ = "Do you" +DGSStl$+ " want to use an Alias? (Y,[N])"
        ZSubParm = 1
        CALL TGet
        IF ZYes THEN
           ABFlg$ = ""
           ZOutTxt$ = "Enter Alias (31 Char. Max.) "
           ZSubParm = 1
           CALL TGet
           CALL AllCaps (ZUserIn$)
           IF ZUserIn$ = "" OR INSTR(SPACE$(31),ZUserIn$) > 0 THEN
              ZUserIn$ = ""
              ABFlg$ = "Alias Must NOT be Blank"
           END IF
           IF LEN(ZUserIn$) > 31 THEN
              ZUserIn$= ""
              ABFlg$ = "Length Must NOT Exceed 31 Characters"
           END IF
           IF ZUserIn$ = "SYSOP" OR ZUserIn$ = DGSSfnSln$ THEN
              ZOutTxt$ = CHR$(7)+CHR$(7)
              ZOutTxt$ = ZOutTxt$ + "Wrong Answer! Alias Request Denied!"
              ZOutTxt$ = ZOutTxt$ + CHR$(13) + "Contact Sysop for Alias Retry"
              CALL QuickTPut (ZOutTxt$,2)
              DGSAlias$ = ZOrigUserNameDGS$+CHR$(250)
              ZActiveUserName$ = ZOrigUserNameDGS$+CHR$(250)
              ZFirstName$ = ZOrigUserNameDGS$+CHR$(250)
           ELSE
              Call OpenWork (7,DGSFileName$)
              WHILE ABFlg$ = "" AND NOT EOF(7)
              INPUT #7, DGSUserName$, DGSTempAlias$
              IF ZUserIn$ = DGSUserName$ THEN
                 ABFlg$ = " is a Real User"
              ELSE
                 IF ZUserIn$ = DGSTempAlias$ THEN
                    ABFlg$ = " has Already been Used"
                 END IF
              END IF
              WEND
              CLOSE 7
              IF ABFlg$="" THEN
                 DGSAlias$ = ZUserIn$
                 ZActiveUserName$ = ZUserIn$
                 ZFirstName$ = ZUserIn$
              ELSE
                 ZOutTxt$="Sorry "+ZFirstName$+" but "+ZUserIn$+ABFlg$
                 CALL QuickTPut (ZOutTxt$,1)
                 DGSStl$ = " still"
                 DGSAlias$ = ""
              END IF
          END IF
        ELSE
           DGSAlias$ = ZOrigUserNameDGS$
        END IF
        IF DGSAlias$ <> "" THEN
           CLOSE 2
           FOR I = 1 TO LEN(DGSAlias$)
              IF MID$(DGSAlias$,I,1)=CHR$(34) THEN MID$(DGSAlias$,I,1)=CHR$(39)
           NEXT I
           Call OpenWorkA (DGSFileName$)
           WRITE #2, ZOrigUserNameDGS$, DGSAlias$
           CLOSE 2
        END IF
      ELSE
        ZActiveUserName$ = DGSAlias$
        ZFirstName$ = DGSAlias$
      END IF
      END SUB
